package vennDIS;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class RWFile {

	public static ArrayList<ArrayList> readTabFile(String filename) {
		ArrayList<ArrayList> dataArray = new ArrayList<ArrayList>();
		ArrayList<String> rawArray = new ArrayList<String>();
		try {
			FileReader fr=new FileReader(filename);
			BufferedReader fbr = new BufferedReader(fr);
			String strLine;	
			while ((strLine = fbr.readLine()) != null) {
				rawArray = new ArrayList<String>();
				strLine = strLine+"\t ";
				String[] elements = strLine.split("\t");
				for (int i=0; i<(elements.length-1); i++) {
					rawArray.add(elements[i]);
				}
			dataArray.add(rawArray);
			}
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		return dataArray;
	}

	public static ArrayList<ArrayList> readCSV(String filename) {
		ArrayList<ArrayList> dataArray = new ArrayList<ArrayList>();
		ArrayList<String> rawArray = new ArrayList<String>();
		try {
			FileReader fr=new FileReader(filename);
			BufferedReader fbr = new BufferedReader(fr);
			String strLine;	
			while ((strLine = fbr.readLine()) != null) {
				rawArray = new ArrayList<String>();
				strLine = strLine+", ";
				String[] elements = strLine.split(",");
				for (int i=0; i<(elements.length-1); i++) {
					rawArray.add(elements[i]);
				}
			dataArray.add(rawArray);
			}
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		return dataArray;
	}


	public static ArrayList<ArrayList> checkForHeaderDuplication(ArrayList<ArrayList> dataArray) {
		ArrayList<String> headers = new ArrayList<String>();
		for (int j=0; j<dataArray.get(0).size(); j++) {
			headers.add(dataArray.get(0).get(j).toString()); 
		}
		Map<String, Integer> headerHashMap = new HashMap<String, Integer>();
		for (int j=0; j<headers.size(); j++) {
			headerHashMap.put(headers.get(j).toString(), 0); 
		}
		for (int j=0; j<headers.size(); j++) {
			if (headerHashMap.get(headers.get(j).toString())==0) { 
				headerHashMap.put(headers.get(j).toString(), 1); 
			} else if (headerHashMap.get(headers.get(j).toString())>0) {
				int i = headerHashMap.get(headers.get(j).toString());
				headerHashMap.put(headers.get(j).toString(), i+1);
				headers.set(j, (headers.get(j)+" ("+i+")"));
			};
			dataArray.set(0, headers);
		}
		return dataArray;
	}

	public static String qCounter(String s, String td) {
		int l = s.length();
		int eq = 0;
		for (int i=(l-1); i>=0; i--) {
			if (s.substring(i, i+1).equals(td)) { eq++; } else { break; }
		}
		String stat = "";
		if (eq%2==0) { 
			stat = "none";
		} else { 
			stat = "end";
		};
		return stat;
	}


	public static ArrayList<ArrayList> readCSV(String filename, String separator, String td) {
		ArrayList<ArrayList> dataArray = new ArrayList<ArrayList>();
		ArrayList<String> rawArray = new ArrayList<String>();
		try {
			FileReader fr=new FileReader(filename);
			BufferedReader fbr = new BufferedReader(fr);
			String strLine;
			while ((strLine = fbr.readLine()) != null) {
				rawArray = new ArrayList<String>();
				strLine = strLine+", ";
				String[] elements = strLine.split(",");
				int m = 0;
				String mStr = "";
				for (int i=0; i<(elements.length-1); i++) {
					String el = elements[i];
					int l = el.length();
					if (m==0 && el.equals("")) {
						mStr = el; 
						rawArray.add(mStr);
						mStr = "";
						continue;
					}
					if (m==0 && el.equals(td+td)) {
						mStr = ""; 
						rawArray.add(mStr);
						continue;
					} 
					if (m==0 && !el.equals("") && !el.substring(0,1).equals(td)) {
						mStr = el;
						rawArray.add(mStr); 
						mStr = "";
						continue;
					}
					if (m==0 && el.substring(0,1).equals(td) && el.equals(td)) {
						mStr = "";
						m = 1;
						continue;
					}
					if (m==0 && el.substring(0,1).equals(td) && el.substring(l-1,l).equals(td)) {
						String qStat = qCounter(el, td);
						if (qStat=="end") {
							mStr += el.substring(1, l-1);
							rawArray.add(mStr);
							mStr = "";
							continue;
						} else {
							mStr += el.substring(1, l);
							m = 1;
							continue;
						}
					}
					if (m==0 && el.substring(0,1).equals(td) && !el.substring(l-1,l).equals(td)) {
						mStr = el.substring(1, l);
						m = 1;
						continue;
					}
 					if (m==1 && el.equals("")) {
						mStr += ","+el;
						continue;
					}
					if (m==1 && !el.substring(l-1,l).equals(td)) {
						mStr += ","+el;
						continue;
					}
					if (m==1 && el.substring(l-1,l).equals(td)) {
						String qStat = qCounter(el, td);
						if (qStat=="none") {
							mStr += ","+el;
						} else {
							mStr += ","+el.substring(0, l-1);
							rawArray.add(mStr);
							mStr = "";
							m = 0;
						}
					}
				}
				for (int i=0; i<rawArray.size(); i++) {
					rawArray.set(i, rawArray.get(i).toString().replace(td+td, td));
				}
			dataArray.add(rawArray);
			}
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		return dataArray;
	}

	public static ArrayList<ArrayList> readCSV2(String filename, String separator, String td) {
		ArrayList<ArrayList> dataArray = new ArrayList<ArrayList>();
		ArrayList<String> rawArray = new ArrayList<String>();
		try {
			FileReader fr=new FileReader(filename);
			BufferedReader fbr = new BufferedReader(fr);
			String strLine;	
			char[] charArray;
			while ((strLine = fbr.readLine()) != null) {
				charArray = strLine.toCharArray();
			}
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		return dataArray;
	}

	public void writeTabFile(String filename, ArrayList<ArrayList> dataArray) {
		try {
			FileWriter fw = new FileWriter(filename);
			for (int i=0; i<dataArray.size(); i++) {
				fw.write(dataArray.get(i).get(0).toString());
				for (int j=1; j<dataArray.get(i).size(); j++) {
					fw.write("\t"+dataArray.get(i).get(j).toString());
				}
				fw.write("\n");
			}
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static ArrayList<String> readList(String filename) {
		ArrayList<String> data = new ArrayList<String>();
		try {
			FileReader fr=new FileReader(filename);
			BufferedReader fbr = new BufferedReader(fr);
			String strLine;	
			while ((strLine = fbr.readLine()) != null) {
				data.add(strLine);
			}
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		return data;
	}

}
